﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Serves : MonoBehaviour {
	public List<Serve> serves = new List<Serve>();
	int cur_serve = 0;

	void Start() {
		List<Serve> s = serves;
		Vector3 fhtp = new Vector3 (-0.5f, 0.8f, 2f); // Toss from forehand side.
		Vector3 bhtp = new Vector3 (0.5f, 0.8f, 2f); // Toss from backhand side.
		Vector3 tv = new Vector3 (0, 4, 0);
		float volley_height = 0.8f;
		Toss vtoss = new Toss (fhtp, tv, volley_height);
		float hit_height = 1.0f;
		Toss fhtoss = new Toss (fhtp, tv, hit_height);
		Toss bhtoss = new Toss (bhtp, tv, hit_height);
		s.Add (new Serve ("Forehand long topspin", fhtoss, new Vector3 (2f, -1f, -7f), -5f));
		s.Add (new Serve ("Forehand long topspin line", bhtoss, new Vector3 (0f, -1f, -7f), -5f));
		s.Add (new Serve ("Backhand long topspin", bhtoss, new Vector3 (-2f, -1f, -7f), -5f));
		s.Add (new Serve ("Backhand long topspin line", fhtoss, new Vector3 (0f, -1f, -7f), -5f));
		s.Add (new Serve ("Forehand short backspin", fhtoss, new Vector3 (2f, -1f, -6f), 5f));
		s.Add (new Serve ("Forehand short backspin line", bhtoss, new Vector3 (0f, -1f, -6f), 5f));
		s.Add (new Serve ("Backhand short backspin", bhtoss, new Vector3 (-2f, -1f, -6f), 5f));
		s.Add (new Serve ("Backhand short backspin line",fhtoss, new Vector3 (0f, -1f, -6f), 5f));
		s.Add (new RandomServe ("Random", new List<Serve>(s)));
		s.Add (new Serve ("Forehand topspin volley", vtoss, new Vector3 (2f, 3f, -6f), -5f));
		s.Add (new Serve ("Backhand topspin volley", vtoss, new Vector3 (0f, 3f, -6f), -5f));
		s.Add (new Serve ("Forehand backspin volley", vtoss, new Vector3 (2f, 3f, -6f), 5f));
		s.Add (new Serve ("Backhand backspin volley", vtoss, new Vector3 (0f, 3f, -5f), 5f));
		cur_serve = 0;
	}

	public Serve current_serve() {
		return serves [cur_serve];
	}

	public Serve set_serve(string name)
	{
		for (int i = 0 ; i < serves.Count ; ++i)
			if (serves[i].name == name)
			{
				cur_serve = i;	
				return serves[i];
			}
		return null;
	}

	public Serve next_serve() {
		cur_serve = (cur_serve + 1) % serves.Count;
		return current_serve ();
	}

	public Serve previous_serve() {
		cur_serve = (cur_serve + serves.Count - 1) % serves.Count;
		return current_serve ();
	}
}

public class RandomServe : Serve {
	public List<Serve> serves;

	public RandomServe(string name, List<Serve> serves) {
		this.name = name;
		this.serves = serves;
	}

	public override void serve_ball(Ball ball, Play play) {
		int i = Random.Range (0, serves.Count);
		serves [i].serve_ball (ball, play);
	}
}
